#!/usr/bin/python
import sys
import Gpib
#import vxi11
import time
import numpy as np

log_name = "../teckit/dcl_1vdc_5720_3458ab_nplc1000.csv"

fluke = Gpib.Gpib(0, 4, timeout=30) #vxi11.Instrument("192.168.1.125", "gpib0,4") # Fluke 5720A, GPIB Address = 1
#fluke.timeout = 30
#fluke.clear()
fluke.write("*IDN?")
print "Source detected = %s" % fluke.read()

dmm =  Gpib.Gpib(0, 22, timeout=30) #vxi11.Instrument("192.168.1.125", "gpib0,3") # Keysight 3458A, GPIB Address = 1
dmm.timeout = 300
#dmm.clear()
#dmm.write("ID?")
#print "DUT1 detected = %s" % dmm.read()

dmm2 = Gpib.Gpib(0, 23, timeout=30) # vxi11.Instrument("192.168.1.125", "gpib0,2") # Keysight 3458A, GPIB Address = 1
dmm2.timeout = 300
#dmm2.clear()
#dmm2.write("ID?")
#print "DUT2 detected = %s" % dmm2.read()

#dmm3 = vxi11.Instrument("192.168.1.125", "gpib0,5") # Fluke 8508A, GPIB Address = 1
#dmm3.timeout = 30
#dmm3.clear()
#dmm3.write("*IDN?")
#print "DUT3 detected = %s" % dmm3.read()

#dmm4 =  Gpib.Gpib(0, 20, timeout=30) #vxi11.Instrument("192.168.1.125", "gpib0,6") # Fluke 8508A, GPIB Address = 1
#dmm4.timeout = 30
#dmm4.clear()
#dmm4.write("*IDN?")
#print "DUT4 detected = %s" % dmm4.read()

fluke.write("RANGELCK OFF")
fluke.write("OUT 1 V, 0 Hz")
fluke.write("RANGELCK ON")
fluke.write("STBY")
fluke.write("OUT 0.0 V, 0 Hz")
fluke.write("EXTGUARD OFF")
fluke.write("OPER")
time.sleep(2)
print "SRC configured"
dmm.write("BEEP")
dmm.write("END ALWAYS")
dmm.write("DCV 1")
dmm.write("NPLC 1000")
dmm.write("NDIG 8")
dmm.write("TRIG AUTO")
dmm.write("MATH OFF")
print "DUT configured, starting ACAL"

dmm2.write("BEEP")
dmm2.write("END ALWAYS")
dmm2.write("DCV 1")
dmm2.write("NPLC 1000")
dmm2.write("NDIG 8")
dmm2.write("TRIG AUTO")
dmm2.write("MATH OFF")
print "DUT2 configured, starting ACAL"

#dmm3.write("*RST")
#dmm3.write("TRG_SRCE EXT")
#dmm3.write("DCV 10,FILT_OFF,RESL8,FAST_OFF,TWO_WR")
#dmm3.write("GUARD INT")
#dmm3.write("GATE FAST_OFF")
#dmm3.write("AVG OFF")
#dmm3.write("INPUT FRONT")
#dmm3.write("C LAST_RDG")
#dmm3.write("SUB_C OFF")
#print "DUT3 configured"

#dmm4.write("*RST")
#dmm4.write(":INIT:CONT OFF")
#dmm4.write(":SYST:PRES")
#dmm4.write(":FORM:ELEM READ")
#dmm4.write(":SYST:AZER:STAT ON")
#dmm4.write(":ABOR")
#dmm4.write(":SENS:CHAN 1")
#dmm4.write(":SENS:FUNC 'VOLT:DC'")
#dmm4.write(":SENS:VOLT:RANG 10")
#dmm4.write(":SENS:VOLT:NPLC 5")
##dmm4.write(":SENS:VOLT:AVER:STAT OFF")
#dmm4.write(":SENS:VOLT:DIG 7")
#print "DUT4 configured"

dmm.write("ACAL DCV")
dmm2.write("ACAL DCV")
time.sleep(160)
'''
for vcnt in range (0,2):
    dmm3.write("*TRG;GET;RDG?")
    dmm3.read()
    dmm4.write("READ?") # Get reading
    dmm4.read()
'''
dmm.write("TARM SGL")
dmm.read()
dmm2.write("TARM SGL")
dmm2.read()
dmm.write("MATH NULL")
dmm2.write("MATH NULL")
#dmm3.write("SUB_C OFF") # Null math
dmm.write("TARM SGL") # Get reading
dmm.read()
dmm2.write("TARM SGL") # Get reading
dmm2.read()
#dmm3.write("*TRG;GET;RDG?") # Get reading
#dmm3.read()
#dmm4.write("READ?") # Get reading
#dmm4.read()
print "DUTs is nulled to MFC zero"

with open(log_name, 'a') as dile:
    dile.write ("date;source;duta;dutb;dutc;dutd;sdev;sdev2;sdev3;sdev4;temp;temp2\r\n")
dile.close()

vcnt = 0 # temporary counter
print "Log into %s started" % log_name

for i in range(-109,110,1):
    median = 0.0
    sdev = 0.0
    array = []
    median2 = 0.0
    sdev2 = 0.0
    array2 = []
    median3 = 0.0
    sdev3 = 0.0
    array3 = []
    median4 = 0.0
    sdev4 = 0.0
    array4 = []
    set_value = (float(i) / 100)
    fluke.write("OUT %.7f" % set_value)
    fluke.write("OPER")
    time.sleep(10)
    for ix in range (0,4): #take more samples
	dmm.write("TARM SGL")
	val = float(dmm.read())
	dmm2.write("TARM SGL")
	val2 = float(dmm2.read())
	#dmm3.write("*TRG;GET;RDG?")
	val3 = set_value#float(dmm3.read())
	#dmm4.write("FETC?")
	val4 = 0#float(dmm4.read())
	time.sleep(1)
	array.extend([val])
	array2.extend([val2])
	array3.extend([val3])
	array4.extend([val4])
	if abs(set_value) >= 0.05:
	    print("\033[33;1mA %.8f, ppm %.4f \033[35;1mB %.8f, ppm %.4f \033[37;1mC %.8f, ppm %.4f \033[32;1mD %.8f, ppm %.4f\033[39;0m" % (val, ((val / set_value - 1) * 1e6), val2,((val2 /set_value - 1) * 1e6), val3,((val3 / set_value - 1) * 1e6),val4,((val4 / set_value - 1) * 1e6) ))
    	if (abs(val) >= 9.9e36) or (abs(val2) >= 9.9e36):
	    print ("Smoke escaped, check connections")
	    fluke.write("OUT 0 V")
	    fluke.write("STBY")
	    quit()
    sdev = np.std(array[1:])
    median = np.median(array[1:])
    sdev2 = np.std(array2[1:])
    median2 = np.median(array2[1:])
    sdev3 = np.std(array3[1:])
    median3 = np.median(array3[1:])
    sdev4 = np.std(array4[1:])
    median4 = np.median(array4[1:])
    if abs(float(i) / 10) >= 0.0005:
	dev1 = ((median / set_value - 1) * 1e6)
	dev2 = ((median2 /set_value - 1) * 1e6)
	dev3 = ((median3 /set_value - 1) * 1e6)
	dev4 = ((median4 /set_value - 1) * 1e6)
	print("\033[32;1mSRC %.5f \033[33;1mA %.9f, sdev5 = %.3f uV, med5 = %.8f\033[35;1mB %.9f, sdev5 = %.3f uV, med5 = %.8f \033[34;1m Delta %.4f ppm \033[37;1mC %.9f, sdev5 = %.3f uV, med5 = %.8f\033[32;1m D %.9f, sdev5 = %.3f uV, med5 = %.8f\033[39;0m" % (set_value, val, sdev*1e6, median, val2,sdev2*1e6, median2, (dev1 - dev2),  val3,sdev3*1e6, median3, val4,sdev4*1e6, median4 ))
        dmm.write("DISP MSG,'%5.3f %2.1fV" % (dev1,set_value ))
        dmm2.write("DISP MSG,'%5.3f %2.1fV" % (dev2,set_value ))
    dmm.write("TEMP?")
    temp = float(dmm.read())
    dmm2.write("TEMP?")
    temp2 = float(dmm2.read())
    with open(log_name, 'a') as dile:
        dile.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.5f;%.9f;%.9f;%.9f;%.9f;%.6g;%.6g;%.6g;%.6g;%.1f;%.1f\r\n" % (set_value, median, median2, median3, median4, sdev, sdev2, sdev3, sdev4, temp, temp2)))
    dile.close()

fluke.write("OUT 0 V")
fluke.write("STBY")
fluke.write("RANGELCK OFF")
dmm.write("RESET")
dmm2.write("RESET")
#dmm3.write("*RST")
#dmm4.write("*RST")